function out = second_deriv(kx, b, c, kc_d, kc_u)
if isempty(kx)
    out = [];
    return
end
bDenseIsDown = kc_d > kc_u;
isImpDn = 1;
isImpTh = 0;
isImpD = bDenseIsDown*isImpDn + ~bDenseIsDown*isImpTh;
isImpU = ~bDenseIsDown*isImpDn + bDenseIsDown*isImpTh;


out = b.*calc_diff2(kc_u, isImpU) +  c.*calc_diff2(kc_d, isImpD);


    function out=calc_diff2(kc, isImp)
        bReal = abs(imag(kx)) <= abs(real(kx))*eps;
        kx(bReal) = kx(bReal)*(1+1j*eps);
        [rows, cols] = size(kx);
        isImp = repmat(isImp, rows, cols);
        isImp(bReal) = 0;
        out = -kc^2./(calc_kc(kc, kx, 1, isImp)).^3;
    end
end