function [x, w] = gausslag(n, alpha, beta)

%Laguerre polynomial
ab=r_laguerre(n, beta);
xw = gauss(n, ab);
%Roots
x=xw(:,1);
w = xw(:,2).*exp(x).*abs(x).^(-beta);
alpha = alpha(:);
x = x(:).';
w = w(:).';
x = (1./alpha)*x;
w = (1./alpha)*w;

% debug
%x = linspace(min(x), 20/abs(alpha), n);
