function out = roots_loop(in)
[rows, cols] = size(in);
out = zeros(rows, cols-1);
for iR = 1:rows
    c = in(iR, :);
    s = roots(c);
    if length(s) < 4
        s = [s; NaN(4-length(s),1)];
    end
    out(iR,:) = s;
end